source: common/libs/func_validate_configs.sh@ 90f5b6d

ablfs-more legacy trunk
Last change on this file since 90f5b6d was 90f5b6d, checked in by Pierre Labastie <pierre@…>, 5 years ago

Remove obsolete blfs_tools dependencies

  • Property mode set to 100644
File size: 11.1 KB
Line 
1# $Id$
2
3declare -r dotSTR=".................."
4
5
6#----------------------------#
7validate_config() { # Are the config values sane (within reason)
8#----------------------------#
9: <<inline_doc
10 Validates the configuration parameters. The global var PROGNAME selects the
11 parameter list.
12
13 input vars: none
14 externals: color constants
15 PROGNAME (lfs,hlfs,clfs,clfs2,clfs3,blfs)
16 modifies: none
17 returns: nothing
18 on error: write text to console and dies
19 on success: write text to console and returns
20inline_doc
21
22 # Common settings by Config.in sections and books family
23 local -r BOOK_common="BOOK CUSTOM_TOOLS"
24 local -r BOOK_clfsX="ARCH TARGET"
25 local -r GENERAL_common="LUSER LGROUP LHOME BUILDDIR CLEAN GETPKG SRC_ARCHIVE \
26 SERVER RETRYSRCDOWNLOAD RETRYDOWNLOADCNT DOWNLOADTIMEOUT \
27 RUNMAKE"
28 local -r BUILD_chroot="TEST BOMB_TEST STRIP"
29 local -r BUILD_common="FSTAB CONFIG TIMEZONE PAGE LANG INSTALL_LOG"
30 local -r ADVANCED_chroot="COMPARE RUN_ICA RUN_FARCE ITERATIONS OPTIMIZE"
31 local -r ADVANCED_common="REPORT REBUILD_MAKEFILE"
32
33 # BOOK Settings by book
34 local -r LFS_book="$BOOK_common INITSYS BLFS_TOOL"
35 #local -r HLFS_added="SET_SSP SET_ASLR SET_PAX SET_HARDENED_TMP SET_WARNINGS \
36 # SET_MISC SET_BLOWFISH"
37 local -r HLFS_added=""
38 local -r HLFS_book="$BOOK_common BLFS_TOOL MODEL KERNEL GRSECURITY_HOST $HLFS_added"
39 local -r CLFS_book="$BOOK_common BLFS_TOOL METHOD $BOOK_clfsX TARGET32 BOOT_CONFIG"
40 local -r CLFS2_book="$BOOK_common BLFS_TOOL $BOOK_clfsX"
41 local -r CLFS3_book="$BOOK_common $BOOK_clfsX PLATFORM MIPS_LEVEL"
42
43 # Build Settings by book
44 local -r LFS_build="$BUILD_chroot VIMLANG DEL_LA_FILES $BUILD_common PKGMNGT FULL_LOCALE WRAP_INSTALL"
45 local -r HLFS_build="$BUILD_chroot $BUILD_common"
46 local -r CLFS_build="$BUILD_chroot VIMLANG $BUILD_common"
47 local -r CLFS2_build="STRIP VIMLANG $BUILD_common"
48 local -r CLFS3_build=" $BUILD_common"
49
50 # System Settings by book (only LFS for now)
51 local -r LFS_system="HOSTNAME INTERFACE IP_ADDR GATEWAY PREFIX BROADCAST DOMAIN DNS1 DNS2 FONT CONSOLE_MAP UNICODE KEYMAP"
52
53 # Full list of books settings
54 local -r lfs_PARAM_LIST="$LFS_book $GENERAL_common $LFS_build $LFS_system $ADVANCED_chroot REALSBU $ADVANCED_common"
55 local -r hlfs_PARAM_LIST="$HLFS_book $GENERAL_common $HLFS_build $ADVANCED_chroot $ADVANCED_common"
56 local -r clfs_PARAM_LIST="$CLFS_book $GENERAL_common $CLFS_build $ADVANCED_chroot $ADVANCED_common"
57 local -r clfs2_PARAM_LIST="$CLFS2_book $GENERAL_common $CLFS2_build $ADVANCED_common"
58 local -r clfs3_PARAM_LIST="$CLFS3_book $GENERAL_common $CLFS3_build $ADVANCED_common"
59# local -r blfs_PARAM_LIST="BRANCH_ID BLFS_ROOT BLFS_XML TRACKING_DIR"
60
61 # Additional variables
62 local -r blfs_tool_PARAM_LIST="\
63 BLFS_TREE BLFS_BRANCH_ID BLFS_ROOT BLFS_XML TRACKING_DIR \
64 DEP_LIBXML DEP_LIBXSLT DEP_DBXML DEP_LYNX DEP_SUDO DEP_WGET \
65 DEP_SVN DEP_GPM"
66 local -r custom_tool_PARAM_LIST="TRACKING_DIR"
67
68 # Internal variables
69 local -r ERROR_MSG_pt1='The variable \"${L_arrow}${config_param}${R_arrow}\" value ${L_arrow}${BOLD}${!config_param}${R_arrow} is invalid,'
70 local -r ERROR_MSG_pt2='rerun make and fix your configuration settings${OFF}'
71 local -r PARAM_VALS='${config_param}${dotSTR:${#config_param}} ${L_arrow}${BOLD}${!config_param}${OFF}${R_arrow}'
72
73 local PARAM_LIST=
74 local config_param
75 local validation_str
76 local save_param
77
78 write_error_and_die() {
79 echo -e "\n${DD_BORDER}"
80 echo -e "`eval echo ${ERROR_MSG_pt1}`" >&2
81 echo -e "`eval echo ${ERROR_MSG_pt2}`" >&2
82 echo -e "${DD_BORDER}\n"
83 exit 1
84 }
85
86# This function is only used when testing package management files.
87 write_pkg_and_die() {
88 echo -e "\n${DD_BORDER}"
89 echo "Package management is requested but" >&2
90 echo -e $* >&2
91 echo -e "${DD_BORDER}\n"
92 exit 1
93 }
94
95 validate_file() {
96 # For parameters ending with a '+' failure causes a warning message only
97 echo -n "`eval echo $PARAM_VALS`"
98 while test $# -gt 0 ; do
99 case $1 in
100 # Failures caused program exit
101 "-z") [[ -z "${!config_param}" ]] && echo "${tab_}<-- NO file name given" && write_error_and_die ;;
102 "-e") [[ ! -e "${!config_param}" ]] && echo "${tab_}<-- file does not exist" && write_error_and_die ;;
103 "-s") [[ ! -s "${!config_param}" ]] && echo "${tab_}<-- file has zero bytes" && write_error_and_die ;;
104 "-r") [[ ! -r "${!config_param}" ]] && echo "${tab_}<-- no read permission " && write_error_and_die ;;
105 "-w") [[ ! -w "${!config_param}" ]] && echo "${tab_}<-- no write permission" && write_error_and_die ;;
106 "-x") [[ ! -x "${!config_param}" ]] && echo "${tab_}<-- file cannot be executed" && write_error_and_die ;;
107 # Warning messages only
108 "-z+") [[ -z "${!config_param}" ]] && echo && return ;;
109 esac
110 shift 1
111 done
112 echo
113 }
114
115 validate_dir() {
116 # For parameters ending with a '+' failure causes a warning message only
117 echo -n "`eval echo $PARAM_VALS`"
118 while test $# -gt 0 ; do
119 case $1 in
120 "-z") [[ -z "${!config_param}" ]] && echo "${tab_}NO directory name given" && write_error_and_die ;;
121 "-d") [[ ! -d "${!config_param}" ]] && echo "${tab_}This is NOT a directory" && write_error_and_die ;;
122 "-w") if [[ ! -w "${!config_param}" ]]; then
123 echo "${nl_}${DD_BORDER}"
124 echo "${tab_}${RED}You do not have ${L_arrow}write${R_arrow}${RED} access to the directory${OFF}"
125 echo "${tab_}${BOLD}${!config_param}${OFF}"
126 echo "${DD_BORDER}${nl_}"
127 exit 1
128 fi ;;
129 # Warnings only
130 "-w+") if [[ ! -w "${!config_param}" ]]; then
131 echo "${nl_}${DD_BORDER}"
132 echo "${tab_}WARNING-- You do not have ${L_arrow}write${R_arrow} access to the directory${OFF}"
133 echo "${tab_} -- ${BOLD}${!config_param}${OFF}"
134 echo "${DD_BORDER}"
135 fi ;;
136 "-z+") [[ -z "${!config_param}" ]] && echo "${tab_}<-- NO directory name given" && return
137 esac
138 shift 1
139 done
140 echo
141 }
142
143 set +e
144 PARAM_GROUP=${PROGNAME}_PARAM_LIST
145 for config_param in ${!PARAM_GROUP}; do
146 case $config_param in
147 # Envvars that depend on other settings to be displayed
148 COMPARE) [[ ! "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
149 RUN_ICA) [[ "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
150 RUN_FARCE) [[ "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
151 ITERATIONS) [[ "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
152 BOMB_TEST) [[ ! "$TEST" = "0" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
153 TARGET32) [[ -n "${TARGET32}" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
154 MIPS_LEVEL) [[ "${ARCH}" = "mips" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
155 SERVER) [[ "$GETPKG" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
156 RETRYSRCDOWNLOAD) [[ "$GETPKG" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
157 RETRYDOWNLOADCNT) [[ "$GETPKG" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
158 DOWNLOADTIMEOUT) [[ "$GETPKG" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
159 REALSBU) [[ "$OPTIMIZE" = "2" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
160
161 # Envars that requires some validation
162 LUSER) echo -e "`eval echo $PARAM_VALS`"
163 [[ "${!config_param}" = "**EDIT ME**" ]] && write_error_and_die
164 ;;
165 LGROUP) echo -e "`eval echo $PARAM_VALS`"
166 [[ "${!config_param}" = "**EDIT ME**" ]] && write_error_and_die
167 ;;
168 # BOOK validation. Very ugly, need be fixed
169 BOOK) if [[ "${WORKING_COPY}" = "y" ]] ; then
170 validate_dir -z -d
171 else
172 echo -e "`eval echo $PARAM_VALS`"
173 fi
174 ;;
175 # Validate directories, testable states:
176 # fatal -z -d -w,
177 # warning -z+ -w+
178 SRC_ARCHIVE) [[ "$GETPKG" = "y" ]] && validate_dir -z+ -d -w+ ;;
179 # The build directory/partition MUST exist and be writable by the user
180 BUILDDIR) validate_dir -z -d
181 [[ "xx x/x" =~ x${!config_param}x ]] && write_error_and_die ;;
182 LHOME) validate_dir -z -d ;;
183
184 # Validate files, testable states:
185 # fatal -z -e -s -w -x -r,
186 # warning -z+
187 FSTAB) validate_file -z+ -e -s ;;
188 CONFIG) validate_file -z+ -e -s ;;
189 BOOT_CONFIG) [[ "${METHOD}" = "boot" ]] && validate_file -z -e -s ;;
190
191 # Treatment of LANG parameter
192 LANG ) # See it the locale value has been set
193 echo -n "`eval echo $PARAM_VALS`"
194 [[ -z "${!config_param}" ]] &&
195 echo " -- Variable $config_param cannot be empty!" &&
196 write_error_and_die
197 echo
198 ;;
199
200 # Treatment of HOSTNAME
201 HOSTNAME) echo -e "`eval echo $PARAM_VALS`"
202 [[ "${!config_param}" = "**EDIT ME**" ]] && write_error_and_die
203 ;;
204
205 # Case of PKGMNGT: two files, packageManager.xml and packInstall.sh
206 # must exist in $PKGMNGTDIR if PKGMNGT='y':
207 PKGMNGT) echo -e "`eval echo $PARAM_VALS`"
208 if [ "$PKGMNGT" = y ]; then
209 if [ ! -e "$PKGMNGTDIR/packageManager.xml" ]; then
210 write_pkg_and_die $PKGMNGTDIR/packageManager.xml does not exist
211 fi
212 if [ ! -e "$PKGMNGTDIR/packInstall.sh" ]; then
213 write_pkg_and_die $PKGMNGTDIR/packInstall.sh does not exist
214 fi
215 if [ ! -s "$PKGMNGTDIR/packageManager.xml" ]; then
216 write_pkg_and_die $PKGMNGTDIR/packageManager.xml has zero size
217 fi
218 if [ ! -s "$PKGMNGTDIR/packInstall.sh" ]; then
219 write_pkg_and_die $PKGMNGTDIR/packInstall.sh has zero size
220 fi
221 if [ ! -r "$PKGMNGTDIR/packageManager.xml" ]; then
222 write_pkg_and_die $PKGMNGTDIR/packageManager.xml is not readable
223 fi
224 if [ ! -r "$PKGMNGTDIR/packInstall.sh" ]; then
225 write_pkg_and_die $PKGMNGTDIR/packInstall.sh is not readable
226 fi
227 fi
228 ;;
229 # Display non-validated envars found in ${PROGNAME}_PARAM_LIST
230 * ) echo -e "`eval echo $PARAM_VALS`" ;;
231
232 esac
233 done
234
235 if [[ "${BLFS_TOOL}" = "y" ]] ; then
236 echo "${nl_} ${BLUE}blfs-tool settings${OFF}"
237 for config_param in ${blfs_tool_PARAM_LIST}; do
238 echo -e "`eval echo $PARAM_VALS`"
239 done
240 fi
241
242 if [[ "${CUSTOM_TOOLS}" = "y" ]] && [[ "${BLFS_TOOL}" = "n" ]] ; then
243 for config_param in ${custom_tool_PARAM_LIST}; do
244 echo -e "`eval echo $PARAM_VALS`"
245 done
246 fi
247
248 set -e
249 echo "${nl_}***${BOLD}${GREEN} ${PARAM_GROUP%%_*T} config parameters look good${OFF} ***${nl_}"
250}
Note: See TracBrowser for help on using the repository browser.